/*
 * $Id: builtin.h,v 1.16 2002/07/10 19:22:59 cssbz Exp $
 */

/*
   Adding a new built-in function to Eden:
     - declare it here in builtin.h
     - declare it in builtinf.h
*/

#if INCLUDE != 'T'

#define paracount	fp->stackp->u.a[0].u.i
#define para(n)		fp->stackp->u.a[n]
#define dpush(x,y,z)	x.type=y; x.u.i=(Int)(z); push(x)

struct BLIBTBL {
	char   *name;
	void	(*func)();
};

extern struct BLIBTBL blibtbl[];

extern void usage();

#endif

/*---------------------------------------------------------*/

#if INCLUDE == 'T'
#define BIND(name,func) {name,func},
#else
#define BIND(name,func) extern void func();
#endif

/*---------------------------------------------------------*/

BIND(	"exit",	 		b_exit		           )
BIND(	"execute", 		exec_string	           )
BIND(	"include", 		exec_file	           )
BIND(	"include_file",		exec_file	           )
BIND(   "_eden_internal_cwd",      _eden_internal_cwd      )
BIND(   "_eden_internal_cd",       _eden_internal_cd       )

#if defined(__CYGWIN__) || defined(HAVE_LIBGEN_H)
BIND(   "_eden_internal_dirname",  _eden_internal_dirname  )
BIND(   "_eden_internal_basename", _eden_internal_basename )
#endif

#ifdef linux
BIND(   "usbhidopen",           usbhidopen                 )
BIND(   "usbhidread",           usbhidread                 )
BIND(   "usbhidclose",          usbhidclose                )
BIND(   "rawserialopen",        rawserialopen              )
BIND(   "rawserialclose",       rawserialclose             )
BIND(   "rawserialread",        rawserialread              )
#endif

BIND(	"apply",	 	apply		           )
BIND(	"substr",	 	substr		)
BIND(	"strcat",	 	scat		)
BIND(	"sublist",		sublist		)
BIND(	"listcat",		lcat		)
BIND(	"type", 		t_type		)
BIND(	"int",			t_int		)
BIND(	"float", 		t_float		)
BIND(	"char", 		t_char		)
BIND(	"str",			t_str		)
BIND(	"_type_convert",	t_super		)
BIND(	"write",		b_write		)
BIND(	"writeln", 		writeln		)
BIND(	"array",		array		)
BIND(	"nameof",		nameof		)
BIND(	"formula_list",		formula_list	)
BIND(	"action_list",		action_list	)
BIND(	"symbols",		symbols		)
BIND(	"symboldetail",		symboldetail	)
BIND(	"symboltext",		symboltext	)
BIND(	"symboltable",		symtbl2list	)
BIND(	"forget",		forget		)
BIND(	"pack",			pack		)
BIND(	"error",		user_error	)
BIND(	"get_msgq",		get_msgq	)
BIND(	"send_msg",		send_message	)
BIND(	"receive_msg",		receive_message	)
BIND(	"remove_msgq",		remove_msgq	)
BIND(	"realrand",		realrand	)
BIND(	"error_no",		error_no	)
BIND(	"backgnd",		backgnd		)
BIND(	"pipe",			pipe_process	)
BIND(   "ipopen",		ipopen          )
BIND(   "ipclose",              ipclose         )
BIND(   "fdready",              fdready         )
BIND(   "rawread",              rawread         )
BIND(   "rawwrite",             rawwrite        )
BIND(   "regmatch",             regmatch        )
BIND(   "regreplace",           regreplace      )
BIND(	"getenv",		get_environ	)
BIND(	"putenv",		put_environ	)
BIND(	"printhash",		printhash	)
BIND(	"touch",		touch		)
BIND(	"gettime",		gettime		)
BIND(	"time",			inttime		)
BIND(	"ftime",		finetime	)
BIND(	"feof",			f_eof		)
BIND(	"getchar",		get_char	)
BIND(	"fgetc",		fget_char	)
BIND(   "stat",                 file_stat       )
BIND(	"gets",			get_string	)
BIND(	"fgets",		fget_string	)
BIND(	"ungetc",		unget_char	)
BIND(	"scanf",		scan_f		)
BIND(	"fscanf",		fscan_f		)
BIND(	"sscanf",		sscan_f		)
#ifdef DISTRIB
BIND(   "sendServer",           sendServer      )
BIND(   "sendClient",           sendClient      )
BIND(   "propagate",            propagate       )
BIND(   "addAgency",            addAgency       )
BIND(   "removeAgency",         removeAgency    )
BIND(   "checkAgency",          checkAgency     )
BIND(   "queryObs",             queryObs        )
BIND(   "renewObs",             renewObs        )
#endif /* DISTRIB */

#ifdef NO_CHECK_CIRCULAR
BIND(	"dcc",			dcc		)
#endif /* NO_CHECK_CIRCULAR */

#ifdef DEBUG
BIND(	"debug", 		debug		)
#endif /* DEBUG */

#ifdef INSTRUMENT
BIND(   "insPrint",             insPrint        )
BIND(   "insReset",             insReset        )
#endif /* INSTRUMENT */

#ifndef TTYEDEN
BIND(	"Disp2PS",		E_Disp2PS	)
BIND(	"StringRemain",		E_StringRemain	)
BIND(	"tcl",			E_tcl		)
BIND(	"DisplayScreen",	DisplayScreen	)
BIND(	"PlotShape",		PlotShape	)
#endif

BIND(	"todo",			todo		)

#if defined(WANT_SASAMI) && !defined(TTYEDEN)
/* Sasami functions */
BIND("sasami_vertex",ed_sasami_vertex)
BIND("sasami_set_bgcolour",ed_sasami_set_bgcolour)
BIND("sasami_poly_geom_vertex",ed_sasami_poly_geom_vertex)
BIND("sasami_poly_tex_vertex",ed_sasami_poly_tex_vertex)
BIND("sasami_poly_colour",ed_sasami_poly_colour)
BIND("sasami_poly_material",ed_sasami_poly_material)
BIND("sasami_object_poly",ed_sasami_object_poly)
BIND("sasami_object_pos",ed_sasami_object_pos)
BIND("sasami_object_rot",ed_sasami_object_rot)
BIND("sasami_object_scale",ed_sasami_object_scale)
BIND("sasami_object_visible",ed_sasami_object_visible)
BIND("sasami_viewport",ed_sasami_viewport)
BIND("sasami_setshowaxes",ed_sasami_setshowaxes)
BIND("sasami_material_ambient",ed_sasami_material_ambient)
BIND("sasami_material_diffuse",ed_sasami_material_diffuse)
BIND("sasami_material_specular",ed_sasami_material_specular)
BIND("sasami_material_texture",ed_sasami_material_texture)
BIND("sasami_light_pos",ed_sasami_light_pos)
BIND("sasami_light_ambient",ed_sasami_light_ambient)
BIND("sasami_light_diffuse",ed_sasami_light_diffuse)
BIND("sasami_light_specular",ed_sasami_light_specular)
BIND("sasami_light_enabled",ed_sasami_light_enabled)
BIND("sasami_light_attenuation",ed_sasami_light_attenuation)
BIND("sasami_light_directional",ed_sasami_light_directional)
#endif /* defined(WANT_SASAMI) && !defined(TTYEDEN) */

BIND("inpdevlineno", inpdevlineno)
BIND("inpdevname", inpdevname)

#undef BIND
