/*
 * $Id: symptr.q.c,v 1.8 2001/07/27 17:57:16 cssbz Exp $
 */

static char rcsid3[] = "$Id: symptr.q.c,v 1.8 2001/07/27 17:57:16 cssbz Exp $";

#include "../config.h"
#include "symptr.q.h"

/* This function has highly concealed semantics.  Note particularly
   the &&: the expression with side-effect on the RHS will only be
   executed if the LHS is true.  The function appears to iterate
   through the given queue until the nth occurrance of obj, then
   returns a new queue pointer to that point.  [Ash] */
/* return the position of the n-th object in a symptr queue [sy or edward] */
symptr_QUEUE *
SEARCH_symptr(symptr_QUEUE * Q, symptr obj, int n)
{
    symptr_QUEUE *P;

    FOREACH(P, Q) {
	if (EQUAL_symptr(obj, P->obj) && !--n)
	    return P;
    }
    return (symptr_QUEUE *) 0;	/* NOT FOUND */
}

void
DELETE_symptr_ATOM(symptr_QUEUE * Q, symptr_ATOM A)
{
    if (A && A != Q) {
	A->prev->next = A->next;
	A->next->prev = A->prev;
	DESTROY_symptr_ATOM(A);
    }
}

void
MOVE_symptr_Q(symptr_QUEUE * Qsrc, symptr_QUEUE * Qdst)
{
    if (!Q_EMPTY(Qsrc)) {
	(Qdst->prev->next = Qsrc->next)->prev = Qdst->prev;
	(Qsrc->prev->next = Qdst)->prev = Qsrc->prev;
	CLEAN_Q(Qsrc);
    }
}
